Index: LMDZ6/branches/Amaury_dev/libf/phylmd/conccm.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/conccm.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/conccm.F90	(revision 5143)
@@ -1,9 +1,10 @@
-
 ! $Header$
 
 SUBROUTINE conccm(dtime, paprs, pplay, t, q, conv_q, d_t, d_q, rain, snow, &
-    kbascm, ktopcm)
+        kbascm, ktopcm)
 
   USE dimphy
+  USE lmdz_YOETHF
+
   IMPLICIT NONE
   ! ======================================================================
@@ -13,9 +14,8 @@
   ! ======================================================================
   include "YOMCST.h"
-  include "YOETHF.h"
 
   ! Entree:
   REAL dtime ! pas d'integration
-  REAL paprs(klon, klev+1) ! pression inter-couche (Pa)
+  REAL paprs(klon, klev + 1) ! pression inter-couche (Pa)
   REAL pplay(klon, klev) ! pression au milieu de couche (Pa)
   REAL t(klon, klev) ! temperature (K)
@@ -43,5 +43,5 @@
 
   LOGICAL usekuo ! utiliser convection profonde (schema Kuo)
-  PARAMETER (usekuo=.TRUE.)
+  PARAMETER (usekuo = .TRUE.)
 
   REAL d_t_bis(klon, klev)
@@ -72,18 +72,18 @@
   DO k = 1, klev
     DO i = 1, klon
-      pt(i, k) = t(i, klev-k+1)
-      pq(i, k) = q(i, klev-k+1)
-      pres(i, k) = pplay(i, klev-k+1)
-      dp(i, k) = paprs(i, klev+1-k) - paprs(i, klev+1-k+1)
+      pt(i, k) = t(i, klev - k + 1)
+      pq(i, k) = q(i, klev - k + 1)
+      pres(i, k) = pplay(i, klev - k + 1)
+      dp(i, k) = paprs(i, klev + 1 - k) - paprs(i, klev + 1 - k + 1)
     END DO
   END DO
   DO i = 1, klon
-    zgeom(i, klev) = rd*t(i, 1)/(0.5*(paprs(i,1)+pplay(i, &
-      1)))*(paprs(i,1)-pplay(i,1))
+    zgeom(i, klev) = rd * t(i, 1) / (0.5 * (paprs(i, 1) + pplay(i, &
+            1))) * (paprs(i, 1) - pplay(i, 1))
   END DO
   DO k = 2, klev
     DO i = 1, klon
-      zgeom(i, klev+1-k) = zgeom(i, klev+1-k+1) + rd*0.5*(t(i,k-1)+t(i,k))/ &
-        paprs(i, k)*(pplay(i,k-1)-pplay(i,k))
+      zgeom(i, klev + 1 - k) = zgeom(i, klev + 1 - k + 1) + rd * 0.5 * (t(i, k - 1) + t(i, k)) / &
+              paprs(i, k) * (pplay(i, k - 1) - pplay(i, k))
     END DO
   END DO
@@ -93,12 +93,12 @@
   DO k = 1, klev
     DO i = 1, klon
-      d_q(i, klev+1-k) = pq(i, k) - q(i, klev+1-k)
-      d_t(i, klev+1-k) = pt(i, k) - t(i, klev+1-k)
+      d_q(i, klev + 1 - k) = pq(i, k) - q(i, klev + 1 - k)
+      d_t(i, klev + 1 - k) = pt(i, k) - t(i, klev + 1 - k)
     END DO
   END DO
 
   DO i = 1, klon
-    rain(i) = cmfprt(i)*rhoh2o
-    snow(i) = cmfprs(i)*rhoh2o
+    rain(i) = cmfprt(i) * rhoh2o
+    snow(i) = cmfprs(i) * rhoh2o
     kbascm(i) = klev + 1 - nbas(i)
     ktopcm(i) = klev + 1 - ntop(i)
@@ -107,5 +107,5 @@
   IF (usekuo) THEN
     CALL conkuo(dtime, paprs, pplay, t, q, conv_q, d_t_bis, d_q_bis, &
-      d_ql_bis, rneb_bis, rain_bis, snow_bis, ibas_bis, itop_bis)
+            d_ql_bis, rneb_bis, rain_bis, snow_bis, ibas_bis, itop_bis)
     DO k = 1, klev
       DO i = 1, klon
@@ -122,10 +122,10 @@
     DO k = 1, klev ! eau liquide convective est
       DO i = 1, klon ! dispersee dans l'air
-        zlvdcp = rlvtt/rcpd/(1.0+rvtmp2*q(i,k))
-        zlsdcp = rlstt/rcpd/(1.0+rvtmp2*q(i,k))
-        zdelta = max(0., sign(1.,rtt-t(i,k)))
+        zlvdcp = rlvtt / rcpd / (1.0 + rvtmp2 * q(i, k))
+        zlsdcp = rlstt / rcpd / (1.0 + rvtmp2 * q(i, k))
+        zdelta = max(0., sign(1., rtt - t(i, k)))
         zz = d_ql_bis(i, k) ! re-evap. de l'eau liquide
         zb = max(0.0, zz)
-        za = -max(0.0, zz)*(zlvdcp*(1.-zdelta)+zlsdcp*zdelta)
+        za = -max(0.0, zz) * (zlvdcp * (1. - zdelta) + zlsdcp * zdelta)
         d_t(i, k) = d_t(i, k) + za
         d_q(i, k) = d_q(i, k) + zb
@@ -134,8 +134,10 @@
   END IF
 
-
 END SUBROUTINE conccm
 SUBROUTINE cmfmca(deltat, p, dp, gz, tb, shb, cmfprt, cmfprs, cnt, cnb)
   USE dimphy
+  USE lmdz_YOETHF
+  USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
+
   IMPLICIT NONE
   ! -----------------------------------------------------------------------
@@ -159,5 +161,5 @@
   ! -----------------------------------------------------------------------
   INTEGER pcnst ! nombre de traceurs passifs
-  PARAMETER (pcnst=1)
+  PARAMETER (pcnst = 1)
   ! ------------------------------Arguments--------------------------------
   ! Input arguments
@@ -194,25 +196,25 @@
   ! ------------------------------Parameters-------------------------------
   REAL c0 ! rain water autoconversion coefficient
-  PARAMETER (c0=1.0E-4)
+  PARAMETER (c0 = 1.0E-4)
   REAL dzmin ! minimum convective depth for precipitation
-  PARAMETER (dzmin=0.0)
+  PARAMETER (dzmin = 0.0)
   REAL betamn ! minimum overshoot parameter
-  PARAMETER (betamn=0.10)
+  PARAMETER (betamn = 0.10)
   REAL cmftau ! characteristic adjustment time scale
-  PARAMETER (cmftau=3600.)
+  PARAMETER (cmftau = 3600.)
   INTEGER limcnv ! top interface level limit for convection
-  PARAMETER (limcnv=1)
+  PARAMETER (limcnv = 1)
   REAL tpmax ! maximum acceptable t perturbation (degrees C)
-  PARAMETER (tpmax=1.50)
+  PARAMETER (tpmax = 1.50)
   REAL shpmax ! maximum acceptable q perturbation (g/g)
-  PARAMETER (shpmax=1.50E-3)
+  PARAMETER (shpmax = 1.50E-3)
   REAL tiny ! arbitrary small num used in transport estimates
-  PARAMETER (tiny=1.0E-36)
+  PARAMETER (tiny = 1.0E-36)
   REAL eps ! convergence criteria (machine dependent)
-  PARAMETER (eps=1.0E-13)
+  PARAMETER (eps = 1.0E-13)
   REAL tmelt ! freezing point of water(req'd for rain vs snow)
-  PARAMETER (tmelt=273.15)
+  PARAMETER (tmelt = 273.15)
   REAL ssfac ! supersaturation bound (detrained air)
-  PARAMETER (ssfac=1.001)
+  PARAMETER (ssfac = 1.001)
 
   ! ---------------------------Local workspace-----------------------------
@@ -222,8 +224,8 @@
   REAL shbs(klon, klev) ! sat. specific humidity (sh bar star)
   REAL hbs(klon, klev) ! sat. moist static energy (h bar star)
-  REAL shbh(klon, klev+1) ! specific humidity on interfaces
-  REAL sbh(klon, klev+1) ! s bar on interfaces
-  REAL hbh(klon, klev+1) ! h bar on interfaces
-  REAL cmrh(klon, klev+1) ! interface constituent mixing ratio
+  REAL shbh(klon, klev + 1) ! specific humidity on interfaces
+  REAL sbh(klon, klev + 1) ! s bar on interfaces
+  REAL hbh(klon, klev + 1) ! h bar on interfaces
+  REAL cmrh(klon, klev + 1) ! interface constituent mixing ratio
   REAL prec(klon) ! instantaneous total precipitation
   REAL dzcld(klon) ! depth of convective layer (m)
@@ -291,8 +293,6 @@
   REAL qhalf, sh1, sh2, shbs1, shbs2
   include "YOMCST.h"
-  include "YOETHF.h"
-  include "FCTTRE.h"
-  qhalf(sh1, sh2, shbs1, shbs2) = min(max(sh1,sh2), &
-    (shbs2*sh1+shbs1*sh2)/(shbs1+shbs2))
+  qhalf(sh1, sh2, shbs1, shbs2) = min(max(sh1, sh2), &
+          (shbs2 * sh1 + shbs1 * sh2) / (shbs1 + shbs2))
 
   ! -----------------------------------------------------------------------
@@ -324,5 +324,5 @@
   dt = deltat
   cats = max(dt, cmftau)
-  rdt = 1.0/dt
+  rdt = 1.0 / dt
 
   ! Compute sb,hb,shbs,hbs
@@ -333,11 +333,11 @@
       zx_p = p(i, k)
       zx_q = shb(i, k)
-      zdelta = max(0., sign(1.,rtt-zx_t))
-      zcvm5 = r5les*rlvtt*(1.-zdelta) + r5ies*rlstt*zdelta
-      zcvm5 = zcvm5/rcpd/(1.0+rvtmp2*zx_q)
-      zx_qs = r2es*foeew(zx_t, zdelta)/zx_p
+      zdelta = max(0., sign(1., rtt - zx_t))
+      zcvm5 = r5les * rlvtt * (1. - zdelta) + r5ies * rlstt * zdelta
+      zcvm5 = zcvm5 / rcpd / (1.0 + rvtmp2 * zx_q)
+      zx_qs = r2es * foeew(zx_t, zdelta) / zx_p
       zx_qs = min(0.5, zx_qs)
-      zcor = 1./(1.-retv*zx_qs)
-      zx_qs = zx_qs*zcor
+      zcor = 1. / (1. - retv * zx_qs)
+      zx_qs = zx_qs * zcor
       zx_gam = foede(zx_t, zdelta, zcvm5, zx_qs, zcor)
       shbs(i, k) = zx_qs
@@ -348,7 +348,7 @@
   DO k = limcnv, klev
     DO i = 1, klon
-      sb(i, k) = rcpd*tb(i, k) + gz(i, k)
-      hb(i, k) = sb(i, k) + rlvtt*shb(i, k)
-      hbs(i, k) = sb(i, k) + rlvtt*shbs(i, k)
+      sb(i, k) = rcpd * tb(i, k) + gz(i, k)
+      hb(i, k) = sb(i, k) + rlvtt * shb(i, k)
+      hbs(i, k) = sb(i, k) + rlvtt * shbs(i, k)
     END DO
   END DO
@@ -359,7 +359,7 @@
     km1 = k - 1
     DO i = 1, klon
-      sbh(i, k) = 0.5*(sb(i,km1)+sb(i,k))
-      shbh(i, k) = qhalf(shb(i,km1), shb(i,k), shbs(i,km1), shbs(i,k))
-      hbh(i, k) = sbh(i, k) + rlvtt*shbh(i, k)
+      sbh(i, k) = 0.5 * (sb(i, km1) + sb(i, k))
+      shbh(i, k) = qhalf(shb(i, km1), shb(i, k), shbs(i, km1), shbs(i, k))
+      hbh(i, k) = sbh(i, k) + rlvtt * shbh(i, k)
     END DO
   END DO
@@ -425,9 +425,9 @@
 
       pblhgt = max(pblh(i), 1.0)
-      IF (gz(i,kp1)/rg<=pblhgt .AND. dzcld(i)==0.0) THEN
-        fac1 = max(0.0, 1.0-gz(i,kp1)/rg/pblhgt)
-        tprime = min(thtap(i), tpmax)*fac1
-        qsattp = shbs(i, kp1) + rcpd/rlvtt*gam(i, kp1)*tprime
-        shprme = min(min(shp(i),shpmax)*fac1, max(qsattp-shb(i,kp1),0.0))
+      IF (gz(i, kp1) / rg<=pblhgt .AND. dzcld(i)==0.0) THEN
+        fac1 = max(0.0, 1.0 - gz(i, kp1) / rg / pblhgt)
+        tprime = min(thtap(i), tpmax) * fac1
+        qsattp = shbs(i, kp1) + rcpd / rlvtt * gam(i, kp1) * tprime
+        shprme = min(min(shp(i), shpmax) * fac1, max(qsattp - shb(i, kp1), 0.0))
         qprime = max(qprime, shprme)
       ELSE
@@ -438,9 +438,9 @@
       ! Specify "updraft" (in-cloud) thermodynamic properties
 
-      sc(i) = sb(i, kp1) + rcpd*tprime
+      sc(i) = sb(i, kp1) + rcpd * tprime
       shc(i) = shb(i, kp1) + qprime
-      hc(i) = sc(i) + rlvtt*shc(i)
+      hc(i) = sc(i) + rlvtt * shc(i)
       flotab(i) = hc(i) - hbs(i, k)
-      dz = dp(i, k)*rd*tb(i, k)/rg/p(i, k)
+      dz = dp(i, k) * rd * tb(i, k) / rg / p(i, k)
       IF (flotab(i)>0.0) THEN
         dzcld(i) = dzcld(i) + dz
@@ -471,8 +471,8 @@
     ! Current level just below top level => no overshoot
 
-    IF (k<=limcnv+1) THEN
+    IF (k<=limcnv + 1) THEN
       DO i = 1, klon
         IF (ldcum(i)) THEN
-          cldwtr(i) = sb(i, k) - sc(i) + flotab(i)/(1.0+gam(i,k))
+          cldwtr(i) = sb(i, k) - sc(i) + flotab(i) / (1.0 + gam(i, k))
           cldwtr(i) = max(0.0, cldwtr(i))
           beta(i) = 0.0
@@ -489,11 +489,11 @@
     DO i = 1, klon
       IF (ldcum(i)) THEN
-        cldwtr(i) = sb(i, k) - sc(i) + flotab(i)/(1.0+gam(i,k))
+        cldwtr(i) = sb(i, k) - sc(i) + flotab(i) / (1.0 + gam(i, k))
         cldwtr(i) = max(0.0, cldwtr(i))
-        betamx = 1.0 - c0*max(0.0, (dzcld(i)-dzmin))
-        b1 = (hc(i)-hbs(i,km1))*dp(i, km1)
-        b2 = (hc(i)-hbs(i,k))*dp(i, k)
-        beta(i) = max(betamn, min(betamx,1.0+b1/b2))
-        IF (hbs(i,km1)<=hb(i,km1)) beta(i) = 0.0
+        betamx = 1.0 - c0 * max(0.0, (dzcld(i) - dzmin))
+        b1 = (hc(i) - hbs(i, km1)) * dp(i, km1)
+        b2 = (hc(i) - hbs(i, k)) * dp(i, k)
+        beta(i) = max(betamn, min(betamx, 1.0 + b1 / b2))
+        IF (hbs(i, km1)<=hb(i, km1)) beta(i) = 0.0
       END IF
     END DO
@@ -507,10 +507,10 @@
     DO i = 1, klon
       IF (ldcum(i)) THEN
-        tmp1 = (1.0+gam(i,k))*(sc(i)-sbh(i,kp1)+cldwtr(i)) - &
-          (hbh(i,kp1)-hc(i))*dp(i, k)/dp(i, kp1)
-        tmp2 = (1.0+gam(i,k))*(sc(i)-sbh(i,k))
-        IF ((beta(i)*tmp2-tmp1)>0.0) THEN
-          betamx = 0.99*(tmp1/tmp2)
-          beta(i) = max(0.0, min(betamx,beta(i)))
+        tmp1 = (1.0 + gam(i, k)) * (sc(i) - sbh(i, kp1) + cldwtr(i)) - &
+                (hbh(i, kp1) - hc(i)) * dp(i, k) / dp(i, kp1)
+        tmp2 = (1.0 + gam(i, k)) * (sc(i) - sbh(i, k))
+        IF ((beta(i) * tmp2 - tmp1)>0.0) THEN
+          betamx = 0.99 * (tmp1 / tmp2)
+          beta(i) = max(0.0, min(betamx, beta(i)))
         END IF
 
@@ -521,16 +521,16 @@
         ! est acceptee (facteur ssfac).
 
-        IF (hb(i,km1)<hbs(i,km1)) THEN
-          tmp1 = (1.0+gam(i,k))*(sc(i)-sbh(i,kp1)+cldwtr(i)) - &
-            (hbh(i,kp1)-hc(i))*dp(i, k)/dp(i, kp1)
-          tmp1 = tmp1/dp(i, k)
-          tmp2 = gam(i, km1)*(sbh(i,k)-sc(i)+cldwtr(i)) - hbh(i, k) + hc(i) - &
-            sc(i) + sbh(i, k)
-          tmp3 = (1.0+gam(i,k))*(sc(i)-sbh(i,k))/dp(i, k)
-          tmp4 = (dt/cats)*(hc(i)-hbs(i,k))*tmp2/(dp(i,km1)*(hbs(i,km1)-hb(i, &
-            km1))) + tmp3
-          IF ((beta(i)*tmp4-tmp1)>0.0) THEN
-            betamx = ssfac*(tmp1/tmp4)
-            beta(i) = max(0.0, min(betamx,beta(i)))
+        IF (hb(i, km1)<hbs(i, km1)) THEN
+          tmp1 = (1.0 + gam(i, k)) * (sc(i) - sbh(i, kp1) + cldwtr(i)) - &
+                  (hbh(i, kp1) - hc(i)) * dp(i, k) / dp(i, kp1)
+          tmp1 = tmp1 / dp(i, k)
+          tmp2 = gam(i, km1) * (sbh(i, k) - sc(i) + cldwtr(i)) - hbh(i, k) + hc(i) - &
+                  sc(i) + sbh(i, k)
+          tmp3 = (1.0 + gam(i, k)) * (sc(i) - sbh(i, k)) / dp(i, k)
+          tmp4 = (dt / cats) * (hc(i) - hbs(i, k)) * tmp2 / (dp(i, km1) * (hbs(i, km1) - hb(i, &
+                  km1))) + tmp3
+          IF ((beta(i) * tmp4 - tmp1)>0.0) THEN
+            betamx = ssfac * (tmp1 / tmp4)
+            beta(i) = max(0.0, min(betamx, beta(i)))
           END IF
         ELSE
@@ -542,16 +542,16 @@
         ! so that the adjustment doesn't contribute to "kinks" in h
 
-        g = min(0.0, hb(i,k)-hb(i,km1))
-        tmp3 = (hb(i,k)-hb(i,km1)-g)*(cats/dt)/(hc(i)-hbs(i,k))
-        tmp1 = (1.0+gam(i,k))*(sc(i)-sbh(i,kp1)+cldwtr(i)) - &
-          (hbh(i,kp1)-hc(i))*dp(i, k)/dp(i, kp1)
-        tmp1 = tmp1/dp(i, k)
-        tmp1 = tmp3*tmp1 + (hc(i)-hbh(i,kp1))/dp(i, k)
-        tmp2 = tmp3*(1.0+gam(i,k))*(sc(i)-sbh(i,k))/dp(i, k) + &
-          (hc(i)-hbh(i,k)-cldwtr(i))*(1.0/dp(i,k)+1.0/dp(i,kp1))
-        IF ((beta(i)*tmp2-tmp1)>0.0) THEN
+        g = min(0.0, hb(i, k) - hb(i, km1))
+        tmp3 = (hb(i, k) - hb(i, km1) - g) * (cats / dt) / (hc(i) - hbs(i, k))
+        tmp1 = (1.0 + gam(i, k)) * (sc(i) - sbh(i, kp1) + cldwtr(i)) - &
+                (hbh(i, kp1) - hc(i)) * dp(i, k) / dp(i, kp1)
+        tmp1 = tmp1 / dp(i, k)
+        tmp1 = tmp3 * tmp1 + (hc(i) - hbh(i, kp1)) / dp(i, k)
+        tmp2 = tmp3 * (1.0 + gam(i, k)) * (sc(i) - sbh(i, k)) / dp(i, k) + &
+                (hc(i) - hbh(i, k) - cldwtr(i)) * (1.0 / dp(i, k) + 1.0 / dp(i, kp1))
+        IF ((beta(i) * tmp2 - tmp1)>0.0) THEN
           betamx = 0.0
-          IF (tmp2/=0.0) betamx = tmp1/tmp2
-          beta(i) = max(0.0, min(betamx,beta(i)))
+          IF (tmp2/=0.0) betamx = tmp1 / tmp2
+          beta(i) = max(0.0, min(betamx, beta(i)))
         END IF
       END IF
@@ -567,35 +567,35 @@
     ! physical states and adjust eta accordingly.
 
-20  CONTINUE
+    20  CONTINUE
     DO i = 1, klon
       IF (ldcum(i)) THEN
         beta(i) = max(0.0, beta(i))
         tmp1 = hc(i) - hbs(i, k)
-        tmp2 = ((1.0+gam(i,k))*(sc(i)-sbh(i,kp1)+cldwtr(i))-beta(i)*(1.0+gam( &
-          i,k))*(sc(i)-sbh(i,k)))/dp(i, k) - (hbh(i,kp1)-hc(i))/dp(i, kp1)
-        eta(i) = tmp1/(tmp2*rg*cats)
-        tmass = min(dp(i,k), dp(i,kp1))/rg
-        IF (eta(i)>tmass*rdt .OR. eta(i)<=0.0) eta(i) = 0.0
+        tmp2 = ((1.0 + gam(i, k)) * (sc(i) - sbh(i, kp1) + cldwtr(i)) - beta(i) * (1.0 + gam(&
+                i, k)) * (sc(i) - sbh(i, k))) / dp(i, k) - (hbh(i, kp1) - hc(i)) / dp(i, kp1)
+        eta(i) = tmp1 / (tmp2 * rg * cats)
+        tmass = min(dp(i, k), dp(i, kp1)) / rg
+        IF (eta(i)>tmass * rdt .OR. eta(i)<=0.0) eta(i) = 0.0
 
         ! Check on negative q in top layer (bound beta)
 
-        IF (shc(i)-shbh(i,k)<0.0 .AND. beta(i)*eta(i)/=0.0) THEN
-          denom = eta(i)*rg*dt*(shc(i)-shbh(i,k))/dp(i, km1)
-          beta(i) = max(0.0, min(-0.999*shb(i,km1)/denom,beta(i)))
+        IF (shc(i) - shbh(i, k)<0.0 .AND. beta(i) * eta(i)/=0.0) THEN
+          denom = eta(i) * rg * dt * (shc(i) - shbh(i, k)) / dp(i, km1)
+          beta(i) = max(0.0, min(-0.999 * shb(i, km1) / denom, beta(i)))
         END IF
 
         ! Check on negative q in middle layer (zero eta)
 
-        qtest1 = shb(i, k) + eta(i)*rg*dt*((shc(i)-shbh(i, &
-          kp1))-(1.0-beta(i))*cldwtr(i)/rlvtt-beta(i)*(shc(i)-shbh(i, &
-          k)))/dp(i, k)
+        qtest1 = shb(i, k) + eta(i) * rg * dt * ((shc(i) - shbh(i, &
+                kp1)) - (1.0 - beta(i)) * cldwtr(i) / rlvtt - beta(i) * (shc(i) - shbh(i, &
+                k))) / dp(i, k)
         IF (qtest1<=0.0) eta(i) = 0.0
 
         ! Check on negative q in lower layer (bound eta)
 
-        fac1 = -(shbh(i,kp1)-shc(i))/dp(i, kp1)
-        qtest2 = shb(i, kp1) - eta(i)*rg*dt*fac1
+        fac1 = -(shbh(i, kp1) - shc(i)) / dp(i, kp1)
+        qtest2 = shb(i, kp1) - eta(i) * rg * dt * fac1
         IF (qtest2<0.0) THEN
-          eta(i) = 0.99*shb(i, kp1)/(rg*dt*fac1)
+          eta(i) = 0.99 * shb(i, kp1) / (rg * dt * fac1)
         END IF
       END IF
@@ -607,34 +607,34 @@
     DO i = 1, klon
       IF (ldcum(i)) THEN
-        etagdt = eta(i)*rg*dt
-        cldwtr(i) = etagdt*cldwtr(i)/rlvtt/rg
-        rnwtr(i) = (1.0-beta(i))*cldwtr(i)
-        ds1(i) = etagdt*(sbh(i,kp1)-sc(i))/dp(i, kp1)
-        dq1(i) = etagdt*(shbh(i,kp1)-shc(i))/dp(i, kp1)
-        ds2(i) = (etagdt*(sc(i)-sbh(i,kp1))+rlvtt*rg*cldwtr(i)-beta(i)*etagdt &
-          *(sc(i)-sbh(i,k)))/dp(i, k)
-        dq2(i) = (etagdt*(shc(i)-shbh(i,kp1))-rg*rnwtr(i)-beta(i)*etagdt*(shc &
-          (i)-shbh(i,k)))/dp(i, k)
-        ds3(i) = beta(i)*(etagdt*(sc(i)-sbh(i,k))-rlvtt*rg*cldwtr(i))/dp(i, &
-          km1)
-        dq3(i) = beta(i)*etagdt*(shc(i)-shbh(i,k))/dp(i, km1)
+        etagdt = eta(i) * rg * dt
+        cldwtr(i) = etagdt * cldwtr(i) / rlvtt / rg
+        rnwtr(i) = (1.0 - beta(i)) * cldwtr(i)
+        ds1(i) = etagdt * (sbh(i, kp1) - sc(i)) / dp(i, kp1)
+        dq1(i) = etagdt * (shbh(i, kp1) - shc(i)) / dp(i, kp1)
+        ds2(i) = (etagdt * (sc(i) - sbh(i, kp1)) + rlvtt * rg * cldwtr(i) - beta(i) * etagdt &
+                * (sc(i) - sbh(i, k))) / dp(i, k)
+        dq2(i) = (etagdt * (shc(i) - shbh(i, kp1)) - rg * rnwtr(i) - beta(i) * etagdt * (shc &
+                (i) - shbh(i, k))) / dp(i, k)
+        ds3(i) = beta(i) * (etagdt * (sc(i) - sbh(i, k)) - rlvtt * rg * cldwtr(i)) / dp(i, &
+                km1)
+        dq3(i) = beta(i) * etagdt * (shc(i) - shbh(i, k)) / dp(i, km1)
 
         ! Isolate convective fluxes for later diagnostics
 
-        fslkp = eta(i)*(sc(i)-sbh(i,kp1))
-        fslkm = beta(i)*(eta(i)*(sc(i)-sbh(i,k))-rlvtt*cldwtr(i)*rdt)
-        fqlkp = eta(i)*(shc(i)-shbh(i,kp1))
-        fqlkm = beta(i)*eta(i)*(shc(i)-shbh(i,k))
+        fslkp = eta(i) * (sc(i) - sbh(i, kp1))
+        fslkm = beta(i) * (eta(i) * (sc(i) - sbh(i, k)) - rlvtt * cldwtr(i) * rdt)
+        fqlkp = eta(i) * (shc(i) - shbh(i, kp1))
+        fqlkm = beta(i) * eta(i) * (shc(i) - shbh(i, k))
 
 
         ! Update thermodynamic profile (update sb, hb, & hbs later)
 
-        tb(i, kp1) = tb(i, kp1) + ds1(i)/rcpd
-        tb(i, k) = tb(i, k) + ds2(i)/rcpd
-        tb(i, km1) = tb(i, km1) + ds3(i)/rcpd
+        tb(i, kp1) = tb(i, kp1) + ds1(i) / rcpd
+        tb(i, k) = tb(i, k) + ds2(i) / rcpd
+        tb(i, km1) = tb(i, km1) + ds3(i) / rcpd
         shb(i, kp1) = shb(i, kp1) + dq1(i)
         shb(i, k) = shb(i, k) + dq2(i)
         shb(i, km1) = shb(i, km1) + dq3(i)
-        prec(i) = prec(i) + rnwtr(i)/rhoh2o
+        prec(i) = prec(i) + rnwtr(i) / rhoh2o
 
         ! Update diagnostic information for final budget
@@ -643,18 +643,18 @@
         ! water static energy flux, and convective total water flux
 
-        cmfdt(i, kp1) = cmfdt(i, kp1) + ds1(i)/rcpd*rdt
-        cmfdt(i, k) = cmfdt(i, k) + ds2(i)/rcpd*rdt
-        cmfdt(i, km1) = cmfdt(i, km1) + ds3(i)/rcpd*rdt
-        cmfdq(i, kp1) = cmfdq(i, kp1) + dq1(i)*rdt
-        cmfdq(i, k) = cmfdq(i, k) + dq2(i)*rdt
-        cmfdq(i, km1) = cmfdq(i, km1) + dq3(i)*rdt
-        cmfdqr(i, k) = cmfdqr(i, k) + (rg*rnwtr(i)/dp(i,k))*rdt
+        cmfdt(i, kp1) = cmfdt(i, kp1) + ds1(i) / rcpd * rdt
+        cmfdt(i, k) = cmfdt(i, k) + ds2(i) / rcpd * rdt
+        cmfdt(i, km1) = cmfdt(i, km1) + ds3(i) / rcpd * rdt
+        cmfdq(i, kp1) = cmfdq(i, kp1) + dq1(i) * rdt
+        cmfdq(i, k) = cmfdq(i, k) + dq2(i) * rdt
+        cmfdq(i, km1) = cmfdq(i, km1) + dq3(i) * rdt
+        cmfdqr(i, k) = cmfdqr(i, k) + (rg * rnwtr(i) / dp(i, k)) * rdt
         cmfmc(i, kp1) = cmfmc(i, kp1) + eta(i)
-        cmfmc(i, k) = cmfmc(i, k) + beta(i)*eta(i)
+        cmfmc(i, k) = cmfmc(i, k) + beta(i) * eta(i)
         cmfsl(i, kp1) = cmfsl(i, kp1) + fslkp
         cmfsl(i, k) = cmfsl(i, k) + fslkm
-        cmflq(i, kp1) = cmflq(i, kp1) + rlvtt*fqlkp
-        cmflq(i, k) = cmflq(i, k) + rlvtt*fqlkm
-        qc(i, k) = (rg*rnwtr(i)/dp(i,k))*rdt
+        cmflq(i, kp1) = cmflq(i, kp1) + rlvtt * fqlkp
+        cmflq(i, k) = cmflq(i, k) + rlvtt * fqlkm
+        qc(i, k) = (rg * rnwtr(i) / dp(i, k)) * rdt
       END IF
     END DO
@@ -669,18 +669,18 @@
           ! the three adjacent levels, nothing will be done to the profile
 
-          IF ((cmrb(i,kp1,m)<0.0) .OR. (cmrb(i,k,m)<0.0) .OR. (cmrb(i,km1, &
-            m)<0.0)) GO TO 40
+          IF ((cmrb(i, kp1, m)<0.0) .OR. (cmrb(i, k, m)<0.0) .OR. (cmrb(i, km1, &
+                  m)<0.0)) GO TO 40
 
           ! Specify constituent interface values (linear interpolation)
 
-          cmrh(i, k) = 0.5*(cmrb(i,km1,m)+cmrb(i,k,m))
-          cmrh(i, kp1) = 0.5*(cmrb(i,k,m)+cmrb(i,kp1,m))
+          cmrh(i, k) = 0.5 * (cmrb(i, km1, m) + cmrb(i, k, m))
+          cmrh(i, kp1) = 0.5 * (cmrb(i, k, m) + cmrb(i, kp1, m))
 
           ! Specify perturbation properties of constituents in PBL
 
           pblhgt = max(pblh(i), 1.0)
-          IF (gz(i,kp1)/rg<=pblhgt .AND. dzcld(i)==0.) THEN
-            fac1 = max(0.0, 1.0-gz(i,kp1)/rg/pblhgt)
-            cmrc(i) = cmrb(i, kp1, m) + cmrp(i, m)*fac1
+          IF (gz(i, kp1) / rg<=pblhgt .AND. dzcld(i)==0.) THEN
+            fac1 = max(0.0, 1.0 - gz(i, kp1) / rg / pblhgt)
+            cmrc(i) = cmrb(i, kp1, m) + cmrp(i, m) * fac1
           ELSE
             cmrc(i) = cmrb(i, kp1, m)
@@ -692,36 +692,36 @@
           ! Tendency is modified (reduced) when pending disaster detected.
 
-          etagdt = eta(i)*rg*dt
-          botflx = etagdt*(cmrc(i)-cmrh(i,kp1))
-          topflx = beta(i)*etagdt*(cmrc(i)-cmrh(i,k))
-          dcmr1(i) = -botflx/dp(i, kp1)
+          etagdt = eta(i) * rg * dt
+          botflx = etagdt * (cmrc(i) - cmrh(i, kp1))
+          topflx = beta(i) * etagdt * (cmrc(i) - cmrh(i, k))
+          dcmr1(i) = -botflx / dp(i, kp1)
           efac1 = 1.0
           efac2 = 1.0
           efac3 = 1.0
 
-          IF (cmrb(i,kp1,m)+dcmr1(i)<0.0) THEN
-            efac1 = max(tiny, abs(cmrb(i,kp1,m)/dcmr1(i))-eps)
+          IF (cmrb(i, kp1, m) + dcmr1(i)<0.0) THEN
+            efac1 = max(tiny, abs(cmrb(i, kp1, m) / dcmr1(i)) - eps)
           END IF
 
           IF (efac1==tiny .OR. efac1>1.0) efac1 = 0.0
-          dcmr1(i) = -efac1*botflx/dp(i, kp1)
-          dcmr2(i) = (efac1*botflx-topflx)/dp(i, k)
-
-          IF (cmrb(i,k,m)+dcmr2(i)<0.0) THEN
-            efac2 = max(tiny, abs(cmrb(i,k,m)/dcmr2(i))-eps)
+          dcmr1(i) = -efac1 * botflx / dp(i, kp1)
+          dcmr2(i) = (efac1 * botflx - topflx) / dp(i, k)
+
+          IF (cmrb(i, k, m) + dcmr2(i)<0.0) THEN
+            efac2 = max(tiny, abs(cmrb(i, k, m) / dcmr2(i)) - eps)
           END IF
 
           IF (efac2==tiny .OR. efac2>1.0) efac2 = 0.0
-          dcmr2(i) = (efac1*botflx-efac2*topflx)/dp(i, k)
-          dcmr3(i) = efac2*topflx/dp(i, km1)
-
-          IF (cmrb(i,km1,m)+dcmr3(i)<0.0) THEN
-            efac3 = max(tiny, abs(cmrb(i,km1,m)/dcmr3(i))-eps)
+          dcmr2(i) = (efac1 * botflx - efac2 * topflx) / dp(i, k)
+          dcmr3(i) = efac2 * topflx / dp(i, km1)
+
+          IF (cmrb(i, km1, m) + dcmr3(i)<0.0) THEN
+            efac3 = max(tiny, abs(cmrb(i, km1, m) / dcmr3(i)) - eps)
           END IF
 
           IF (efac3==tiny .OR. efac3>1.0) efac3 = 0.0
           efac3 = min(efac2, efac3)
-          dcmr2(i) = (efac1*botflx-efac3*topflx)/dp(i, k)
-          dcmr3(i) = efac3*topflx/dp(i, km1)
+          dcmr2(i) = (efac1 * botflx - efac3 * topflx) / dp(i, k)
+          dcmr3(i) = efac3 * topflx / dp(i, km1)
 
           cmrb(i, kp1, m) = cmrb(i, kp1, m) + dcmr1(i)
@@ -729,8 +729,8 @@
           cmrb(i, km1, m) = cmrb(i, km1, m) + dcmr3(i)
         END IF
-40    END DO
+      40    END DO
     END DO ! end of m=1,pcnst loop
 
-    IF (k==limcnv+1) GO TO 60 ! on ne pourra plus glisser
+    IF (k==limcnv + 1) GO TO 60 ! on ne pourra plus glisser
 
     ! Dans la procedure de glissage ascendant, les variables thermo-
@@ -743,11 +743,11 @@
         zx_p = p(i, k)
         zx_q = shb(i, k)
-        zdelta = max(0., sign(1.,rtt-zx_t))
-        zcvm5 = r5les*rlvtt*(1.-zdelta) + r5ies*rlstt*zdelta
-        zcvm5 = zcvm5/rcpd/(1.0+rvtmp2*zx_q)
-        zx_qs = r2es*foeew(zx_t, zdelta)/zx_p
+        zdelta = max(0., sign(1., rtt - zx_t))
+        zcvm5 = r5les * rlvtt * (1. - zdelta) + r5ies * rlstt * zdelta
+        zcvm5 = zcvm5 / rcpd / (1.0 + rvtmp2 * zx_q)
+        zx_qs = r2es * foeew(zx_t, zdelta) / zx_p
         zx_qs = min(0.5, zx_qs)
-        zcor = 1./(1.-retv*zx_qs)
-        zx_qs = zx_qs*zcor
+        zcor = 1. / (1. - retv * zx_qs)
+        zx_qs = zx_qs * zcor
         zx_gam = foede(zx_t, zdelta, zcvm5, zx_qs, zcor)
         shbs(i, k) = zx_qs
@@ -757,11 +757,11 @@
         zx_p = p(i, km1)
         zx_q = shb(i, km1)
-        zdelta = max(0., sign(1.,rtt-zx_t))
-        zcvm5 = r5les*rlvtt*(1.-zdelta) + r5ies*rlstt*zdelta
-        zcvm5 = zcvm5/rcpd/(1.0+rvtmp2*zx_q)
-        zx_qs = r2es*foeew(zx_t, zdelta)/zx_p
+        zdelta = max(0., sign(1., rtt - zx_t))
+        zcvm5 = r5les * rlvtt * (1. - zdelta) + r5ies * rlstt * zdelta
+        zcvm5 = zcvm5 / rcpd / (1.0 + rvtmp2 * zx_q)
+        zx_qs = r2es * foeew(zx_t, zdelta) / zx_p
         zx_qs = min(0.5, zx_qs)
-        zcor = 1./(1.-retv*zx_qs)
-        zx_qs = zx_qs*zcor
+        zcor = 1. / (1. - retv * zx_qs)
+        zx_qs = zx_qs * zcor
         zx_gam = foede(zx_t, zdelta, zcvm5, zx_qs, zcor)
         shbs(i, km1) = zx_qs
@@ -770,16 +770,16 @@
         sb(i, k) = sb(i, k) + ds2(i)
         sb(i, km1) = sb(i, km1) + ds3(i)
-        hb(i, k) = sb(i, k) + rlvtt*shb(i, k)
-        hb(i, km1) = sb(i, km1) + rlvtt*shb(i, km1)
-        hbs(i, k) = sb(i, k) + rlvtt*shbs(i, k)
-        hbs(i, km1) = sb(i, km1) + rlvtt*shbs(i, km1)
-
-        sbh(i, k) = 0.5*(sb(i,k)+sb(i,km1))
-        shbh(i, k) = qhalf(shb(i,km1), shb(i,k), shbs(i,km1), shbs(i,k))
-        hbh(i, k) = sbh(i, k) + rlvtt*shbh(i, k)
-        sbh(i, km1) = 0.5*(sb(i,km1)+sb(i,k-2))
-        shbh(i, km1) = qhalf(shb(i,k-2), shb(i,km1), shbs(i,k-2), &
-          shbs(i,km1))
-        hbh(i, km1) = sbh(i, km1) + rlvtt*shbh(i, km1)
+        hb(i, k) = sb(i, k) + rlvtt * shb(i, k)
+        hb(i, km1) = sb(i, km1) + rlvtt * shb(i, km1)
+        hbs(i, k) = sb(i, k) + rlvtt * shbs(i, k)
+        hbs(i, km1) = sb(i, km1) + rlvtt * shbs(i, km1)
+
+        sbh(i, k) = 0.5 * (sb(i, k) + sb(i, km1))
+        shbh(i, k) = qhalf(shb(i, km1), shb(i, k), shbs(i, km1), shbs(i, k))
+        hbh(i, k) = sbh(i, k) + rlvtt * shbh(i, k)
+        sbh(i, km1) = 0.5 * (sb(i, km1) + sb(i, k - 2))
+        shbh(i, km1) = qhalf(shb(i, k - 2), shb(i, km1), shbs(i, k - 2), &
+                shbs(i, km1))
+        hbh(i, km1) = sbh(i, km1) + rlvtt * shbh(i, km1)
       END IF
     END DO
@@ -789,5 +789,5 @@
     ! top of convective layer determined by size of overshoot param.
 
-60  CONTINUE
+    60  CONTINUE
     DO i = 1, klon
       etagt0 = eta(i) > 0.0
@@ -803,13 +803,13 @@
       END IF
     END DO
-70 END DO ! end of k loop
+  70 END DO ! end of k loop
 
   ! determine whether precipitation, prec, is frozen (snow) or not
 
   DO i = 1, klon
-    IF (tb(i,klev)<tmelt .AND. tb(i,klev-1)<tmelt) THEN
-      cmfprs(i) = prec(i)*rdt
+    IF (tb(i, klev)<tmelt .AND. tb(i, klev - 1)<tmelt) THEN
+      cmfprs(i) = prec(i) * rdt
     ELSE
-      cmfprt(i) = prec(i)*rdt
+      cmfprt(i) = prec(i) * rdt
     END IF
   END DO
